Index: django/db/backends/creation.py
===================================================================
--- django/db/backends/creation.py	(revision 17914)
+++ django/db/backends/creation.py	(working copy)
@@ -2,7 +2,9 @@
 import time
 
 from django.conf import settings
+from django.db import QName
 from django.db.utils import load_backend
+from django.core.management.color import no_style
 
 # The prefix to put on the default database name when creating
 # the test database.
@@ -28,6 +30,14 @@
         """
         return '%x' % (abs(hash(args)) % 4294967296L)  # 2**32
 
+    def sql_create_schema(self, schema, style):
+        """
+        Returns the SQL required to create a single schema
+        """
+        qn = self.connection.ops.quote_name
+        output = "%s %s;" % (style.SQL_KEYWORD('CREATE SCHEMA'), qn(schema))
+        return output
+
     def sql_create_model(self, model, style, known_models=set()):
         """
         Returns the SQL required to create a single model, as a tuple of:
@@ -40,6 +50,7 @@
         table_output = []
         pending_references = {}
         qn = self.connection.ops.quote_name
+        qn3 = self.connection.ops.qualified_name
         for f in opts.local_fields:
             col_type = f.db_type(connection=self.connection)
             tablespace = f.db_tablespace or opts.db_tablespace
@@ -79,7 +90,7 @@
                      for f in field_constraints]))
 
         full_statement = [style.SQL_KEYWORD('CREATE TABLE') + ' ' +
-                          style.SQL_TABLE(qn(opts.db_table)) + ' (']
+                          style.SQL_TABLE(qn3(opts.qualified_name)) + ' (']
         for i, line in enumerate(table_output): # Combine and add commas.
             full_statement.append(
                 '    %s%s' % (line, i < len(table_output)-1 and ',' or ''))
@@ -96,7 +107,7 @@
             # Add any extra SQL needed to support auto-incrementing primary
             # keys.
             auto_column = opts.auto_field.db_column or opts.auto_field.name
-            autoinc_sql = self.connection.ops.autoinc_sql(opts.db_table,
+            autoinc_sql = self.connection.ops.autoinc_sql(opts.qualified_name,
                                                           auto_column)
             if autoinc_sql:
                 for stmt in autoinc_sql:
@@ -109,9 +120,12 @@
         Return the SQL snippet defining the foreign key reference for a field.
         """
         qn = self.connection.ops.quote_name
+        from_qname = field.model._meta.qualified_name
+        to_qname = field.rel.to._meta.qualified_name
+        qname = self.qualified_name_for_ref(from_qname, to_qname)
         if field.rel.to in known_models:
             output = [style.SQL_KEYWORD('REFERENCES') + ' ' +
-                style.SQL_TABLE(qn(field.rel.to._meta.db_table)) + ' (' +
+                style.SQL_TABLE(qname) + ' (' +
                 style.SQL_FIELD(qn(field.rel.to._meta.get_field(
                     field.rel.field_name).column)) + ')' +
                 self.connection.ops.deferrable_sql()
@@ -132,16 +146,24 @@
         from django.db.backends.util import truncate_name
 
         if not model._meta.managed or model._meta.proxy:
+            # So, we have a reference to either unmanaged model or to
+            # a proxy model. Lets just clear the pending_references
+            # for now.
+            if model in pending_references:
+                del pending_references[model]
             return []
         qn = self.connection.ops.quote_name
+        qn3 = self.connection.ops.qualified_name
         final_output = []
         opts = model._meta
         if model in pending_references:
             for rel_class, f in pending_references[model]:
                 rel_opts = rel_class._meta
                 r_table = rel_opts.db_table
+                r_qname = rel_opts.qualified_name
                 r_col = f.column
                 table = opts.db_table
+                qname = self.qualified_name_for_ref(r_qname, opts.qualified_name)
                 col = opts.get_field(f.rel.field_name).column
                 # For MySQL, r_name must be unique in the first 64 characters.
                 # So we are careful with character usage here.
@@ -149,13 +171,23 @@
                     r_col, col, self._digest(r_table, table))
                 final_output.append(style.SQL_KEYWORD('ALTER TABLE') +
                     ' %s ADD CONSTRAINT %s FOREIGN KEY (%s) REFERENCES %s (%s)%s;' %
-                    (qn(r_table), qn(truncate_name(
+                    (qn3(r_qname), qn(truncate_name(
                         r_name, self.connection.ops.max_name_length())),
-                    qn(r_col), qn(table), qn(col),
+                    qn(r_col), qname, qn(col),
                     self.connection.ops.deferrable_sql()))
             del pending_references[model]
         return final_output
 
+    def qualified_name_for_ref(self, from_table, ref_table):
+        """
+        In certain databases if the from_table is in qualified format and
+        ref_table is not, it is assumed the ref_table references a table
+        in the same schema as from_table is from. However, we want the
+        reference to be to default schema, not the same schema the from_table
+        is. This method will fix this issue where that is a problem.
+        """
+        return self.connection.ops.qualified_name(ref_table)
+
     def sql_indexes_for_model(self, model, style):
         """
         Returns the CREATE INDEX SQL statements for a single model.
@@ -171,10 +203,9 @@
         """
         Return the CREATE INDEX SQL statements for a single model field.
         """
-        from django.db.backends.util import truncate_name
-
         if f.db_index and not f.unique:
             qn = self.connection.ops.quote_name
+            qn3 = self.connection.ops.qualified_name
             tablespace = f.db_tablespace or model._meta.db_tablespace
             if tablespace:
                 tablespace_sql = self.connection.ops.tablespace_sql(tablespace)
@@ -182,18 +213,36 @@
                     tablespace_sql = ' ' + tablespace_sql
             else:
                 tablespace_sql = ''
-            i_name = '%s_%s' % (model._meta.db_table, self._digest(f.column))
+            qualified_name = self.qualified_index_name(model, f.column) 
             output = [style.SQL_KEYWORD('CREATE INDEX') + ' ' +
-                style.SQL_TABLE(qn(truncate_name(
-                    i_name, self.connection.ops.max_name_length()))) + ' ' +
+                style.SQL_TABLE(qualified_name) + ' ' +
                 style.SQL_KEYWORD('ON') + ' ' +
-                style.SQL_TABLE(qn(model._meta.db_table)) + ' ' +
+                style.SQL_TABLE(qn3(model._meta.qualified_name)) + ' ' +
                 "(%s)" % style.SQL_FIELD(qn(f.column)) +
                 "%s;" % tablespace_sql]
         else:
             output = []
         return output
 
+    def qualified_index_name(self, model, col):
+        """
+        Some databases do support schemas, but indexes can not be placed in a
+        different schema. So, to support those databases, we need to be able
+        to return the index name in different qualified format than the rest
+        of the database identifiers.
+        """
+        from django.db.backends.util import truncate_name
+        i_name = '%s_%s' % (model._meta.db_table, self._digest(col))
+        i_name = truncate_name(i_name, self.connection.ops.max_name_length())
+        return self.connection.ops.qualified_name(
+            QName(model._meta.db_schema, i_name, False))
+
+    def sql_destroy_schema(self, schema, style):
+        """
+        Returns the SQL required to destroy a single schema.
+        """
+        return ""
+
     def sql_destroy_model(self, model, references_to_delete, style):
         """
         Return the DROP TABLE and restraint dropping statements for a single
@@ -202,14 +251,14 @@
         if not model._meta.managed or model._meta.proxy:
             return []
         # Drop the table now
-        qn = self.connection.ops.quote_name
+        qn3 = self.connection.ops.qualified_name
         output = ['%s %s;' % (style.SQL_KEYWORD('DROP TABLE'),
-                              style.SQL_TABLE(qn(model._meta.db_table)))]
+                              style.SQL_TABLE(qn3(model._meta.qualified_name)))]
         if model in references_to_delete:
             output.extend(self.sql_remove_table_constraints(
                 model, references_to_delete, style))
         if model._meta.has_auto_field:
-            ds = self.connection.ops.drop_sequence_sql(model._meta.db_table)
+            ds = self.connection.ops.drop_sequence_sql(model._meta.qualified_name)
             if ds:
                 output.append(ds)
         return output
@@ -220,8 +269,10 @@
             return []
         output = []
         qn = self.connection.ops.quote_name
+        qn3 = self.connection.ops.qualified_name
         for rel_class, f in references_to_delete[model]:
             table = rel_class._meta.db_table
+            qname = rel_class._meta.qualified_name
             col = f.column
             r_table = model._meta.db_table
             r_col = model._meta.get_field(f.rel.field_name).column
@@ -229,7 +280,7 @@
                 col, r_col, self._digest(table, r_table))
             output.append('%s %s %s %s;' % \
                 (style.SQL_KEYWORD('ALTER TABLE'),
-                style.SQL_TABLE(qn(table)),
+                style.SQL_TABLE(qn3(qname)),
                 style.SQL_KEYWORD(self.connection.ops.drop_foreignkey_sql()),
                 style.SQL_FIELD(qn(truncate_name(
                     r_name, self.connection.ops.max_name_length())))))
@@ -240,6 +291,10 @@
         """
         Creates a test database, prompting the user for confirmation if the
         database already exists. Returns the name of the test database created.
+
+        Also creates needed schemas, which on some backends live in the same
+        namespace than databases. If there are schema name clashes, prompts
+        the user for confirmation.
         """
         # Don't import django.core.management if it isn't needed.
         from django.core.management import call_command
@@ -253,10 +308,14 @@
             print "Creating test database for alias '%s'%s..." % (
                 self.connection.alias, test_db_repr)
 
-        self._create_test_db(verbosity, autoclobber)
+        schemas = self.get_schemas()
+        self._create_test_db(verbosity, autoclobber, schemas)
 
+        # Create the test schemas.
+        self.connection.settings_dict["NAME"] = test_database_name
         self.connection.close()
-        self.connection.settings_dict["NAME"] = test_database_name
+        schemas = ['%s%s' % (self.connection.test_schema_prefix, s) for s in schemas]
+        created_schemas = self._create_test_schemas(verbosity, schemas, autoclobber)
 
         # Confirm the feature set of the test database
         self.connection.features.confirm()
@@ -292,8 +351,61 @@
         # the side effect of initializing the test database.
         self.connection.cursor()
 
-        return test_database_name
+        return test_database_name, created_schemas
 
+    def _create_test_schemas(self, verbosity, schemas, autoclobber):
+        style = no_style()
+        cursor = self.connection.cursor()
+        existing_schemas = self.connection.introspection.get_schema_list(cursor)
+        if not self.connection.features.namespaced_schemas:
+            conflicts = [s for s in existing_schemas if s in schemas]
+        else:
+            conflicts = []
+        if conflicts:
+            print 'The following schemas already exists: %s' % ', '.join(conflicts) 
+            if not autoclobber:
+                confirm = raw_input(
+                    "Type 'yes' if you would like to try deleting these schemas "
+                    "or 'no' to cancel: ")
+            if autoclobber or confirm == 'yes':
+                try:
+                    # Some databases (well, MySQL) complain about foreign keys when
+                    # dropping a database. So, disable the constraints temporarily.
+                    self.connection.disable_constraint_checking()
+                    for schema in conflicts:
+                        if verbosity >= 1:
+                            print "Destroying schema %s" % schema
+                        cursor.execute(self.sql_destroy_schema(schema, style))
+                        existing_schemas.remove(schema)
+                finally:
+                    self.connection.enable_constraint_checking()
+            else:
+                print "Tests cancelled."
+                sys.exit(1)
+           
+        to_create = [s for s in schemas if s not in existing_schemas]
+        for schema in to_create:
+            if verbosity >= 1:
+                print "Creating schema %s" % schema
+            cursor.execute(self.sql_create_schema(schema, style))
+            self.connection.settings_dict['TEST_SCHEMAS'].append(schema)
+        return to_create
+
+    def get_schemas(self):
+        from django.db import models
+        apps = models.get_apps()
+        schemas = set()
+        for app in apps:
+            app_models = models.get_models(app, include_auto_created=True)
+            for model in app_models:
+                schema = model._meta.db_schema
+                if schema:
+                    schemas.add(schema)
+        conn_default_schema = self.connection.settings_dict['SCHEMA']
+        if conn_default_schema:
+            schemas.add(conn_default_schema)
+        return schemas
+
     def _get_test_db_name(self):
         """
         Internal implementation - returns the name of the test DB that will be
@@ -305,7 +417,7 @@
             return self.connection.settings_dict['TEST_NAME']
         return TEST_DATABASE_PREFIX + self.connection.settings_dict['NAME']
 
-    def _create_test_db(self, verbosity, autoclobber):
+    def _create_test_db(self, verbosity, autoclobber, schemas):
         """
         Internal implementation - creates the test db tables.
         """
@@ -335,9 +447,19 @@
                     if verbosity >= 1:
                         print ("Destroying old test database '%s'..."
                                % self.connection.alias)
+                    # MySQL nicely doesn't have a drop-cascade option, nor
+                    # does it allow dropping a database having foreign key
+                    # references pointing to it. So, we just disable foreign
+                    # key checks and then immediately enable them. MySQL is
+                    # happy after this hack, and other databases simply do
+                    # not care.
+                    try:
+                        self.connection.disable_constraint_checking()
+                        cursor.execute(
+                            "DROP DATABASE %s" % qn(test_database_name))
+                    finally:
+                        self.connection.enable_constraint_checking()
                     cursor.execute(
-                        "DROP DATABASE %s" % qn(test_database_name))
-                    cursor.execute(
                         "CREATE DATABASE %s %s" % (qn(test_database_name),
                                                    suffix))
                 except Exception, e:
@@ -348,15 +470,32 @@
                 print "Tests cancelled."
                 sys.exit(1)
 
+        self.connection.settings_dict['TEST_SCHEMAS'].append(test_database_name)
         return test_database_name
 
-    def destroy_test_db(self, old_database_name, verbosity=1):
+    def destroy_test_db(self, old_database_name, created_schemas, verbosity=1):
         """
         Destroy a test database, prompting the user for confirmation if the
         database already exists.
         """
+        # On databases where there is no support for multiple databases
+        # with multiple schemas we need to destroy the created schemas
+        # manually.
+        cursor = self.connection.cursor()
+        style = no_style()
+        if not self.connection.features.namespaced_schemas:
+            try:
+                self.connection.disable_constraint_checking()
+                for schema in created_schemas:
+                    if verbosity >= 1:
+                        print "Destroying schema '%s'..." % schema
+                    cursor.execute(self.sql_destroy_schema(schema, style))
+            finally:
+                self.connection.enable_constraint_checking()
         self.connection.close()
         test_database_name = self.connection.settings_dict['NAME']
+                    
+
         if verbosity >= 1:
             test_db_repr = ''
             if verbosity >= 2:
@@ -429,3 +568,11 @@
             settings_dict['ENGINE'],
             settings_dict['NAME']
         )
+
+    def post_create_pending_references(self, pending_references, as_sql=False):
+        """
+        Create any pending references which need special handling (for example
+        different connections). The as_sql flag tells us if we should return
+        the raw SQL used. This is needed for the "sql" management commands.
+        """
+        raise NotImplementedError
Index: django/db/backends/sqlite3/base.py
===================================================================
--- django/db/backends/sqlite3/base.py	(revision 17914)
+++ django/db/backends/sqlite3/base.py	(working copy)
@@ -11,7 +11,7 @@
 import re
 import sys
 
-from django.db import utils
+from django.db import utils, QName
 from django.db.backends import *
 from django.db.backends.signals import connection_created
 from django.db.backends.sqlite3.client import DatabaseClient
@@ -84,6 +84,11 @@
     supports_mixed_date_datetime_comparisons = False
     has_bulk_insert = True
     can_combine_inserts_with_and_without_auto_increment_pk = True
+    supports_foreign_keys = False
+    # SQLite doesn't support schemas at all, but our hack of appending
+    # the schema name to table name creates namespaced schemas from
+    # Django's perspective
+    namespaced_schemas = True
 
     def _supports_stddev(self):
         """Confirm support for STDDEV and related stats functions
@@ -139,6 +144,22 @@
             return name # Quoting once is enough.
         return '"%s"' % name
 
+    def qualified_name(self, qname):
+        # Fake schema support by using the schema as a prefix to the
+        # table name. Keep record of what names are already qualified
+        # to avoid double-qualifying.
+        assert isinstance(qname, QName)
+        if qname.db_format:
+            # A name from DB must not have a schema (no schema support)
+            assert not qname.schema
+            schema = None
+        else:
+            schema = qname.schema or self.connection.schema
+        if schema:
+            return self.quote_name('%s_%s' % (schema, qname.table))
+        else:
+            return self.quote_name(qname.table)
+
     def no_limit_value(self):
         return -1
 
@@ -146,11 +167,13 @@
         # NB: The generated SQL below is specific to SQLite
         # Note: The DELETE FROM... SQL generated below works for SQLite databases
         # because constraints don't exist
-        sql = ['%s %s %s;' % \
+        sql = []
+        for table in tables:
+            sql.append('%s %s %s;' % \
                 (style.SQL_KEYWORD('DELETE'),
                  style.SQL_KEYWORD('FROM'),
-                 style.SQL_FIELD(self.quote_name(table))
-                 ) for table in tables]
+                 style.SQL_FIELD(self.qualified_name(table))
+                 ))
         # Note: No requirement for reset of auto-incremented indices (cf. other
         # sql_flush() implementations). Just return SQL at this point
         return sql
@@ -243,6 +266,10 @@
         self.introspection = DatabaseIntrospection(self)
         self.validation = BaseDatabaseValidation(self)
 
+    def convert_schema(self, schema):
+        # No real schema support.
+        return None
+
     def _sqlite_create_connection(self):
         settings_dict = self.settings_dict
         if not settings_dict['NAME']:
@@ -295,7 +322,9 @@
         """
         cursor = self.cursor()
         if table_names is None:
-            table_names = self.introspection.get_table_list(cursor)
+            table_names = self.introspection.get_visible_tables_list(cursor)
+        else:
+            table_names = [self.introspection.qname_converter(t) for t in table_names]
         for table_name in table_names:
             primary_key_column_name = self.introspection.get_primary_key_column(cursor, table_name)
             if not primary_key_column_name:
@@ -307,12 +336,12 @@
                     LEFT JOIN `%s` as REFERRED
                     ON (REFERRING.`%s` = REFERRED.`%s`)
                     WHERE REFERRING.`%s` IS NOT NULL AND REFERRED.`%s` IS NULL"""
-                    % (primary_key_column_name, column_name, table_name, referenced_table_name,
+                    % (primary_key_column_name, column_name, table_name[1], referenced_table_name[1],
                     column_name, referenced_column_name, column_name, referenced_column_name))
                 for bad_row in cursor.fetchall():
                     raise utils.IntegrityError("The row in table '%s' with primary key '%s' has an invalid "
                         "foreign key: %s.%s contains a value '%s' that does not have a corresponding value in %s.%s."
-                        % (table_name, bad_row[0], table_name, column_name, bad_row[1],
+                        % (table_name, bad_row[0], table_name[1], column_name, bad_row[1],
                         referenced_table_name, referenced_column_name))
 
     def close(self):
Index: django/db/backends/sqlite3/introspection.py
===================================================================
--- django/db/backends/sqlite3/introspection.py	(revision 17914)
+++ django/db/backends/sqlite3/introspection.py	(working copy)
@@ -1,4 +1,5 @@
 import re
+from django.db import QName
 from django.db.backends import BaseDatabaseIntrospection
 
 # This light wrapper "fakes" a dictionary interface, because some SQLite data
@@ -41,26 +42,27 @@
 class DatabaseIntrospection(BaseDatabaseIntrospection):
     data_types_reverse = FlexibleFieldLookupDict()
 
-    def get_table_list(self, cursor):
-        "Returns a list of table names in the current database."
+    def get_visible_tables_list(self, cursor):
+        "Returns a list of table names in the current database"
         # Skip the sqlite_sequence system table used for autoincrement key
         # generation.
         cursor.execute("""
             SELECT name FROM sqlite_master
             WHERE type='table' AND NOT name='sqlite_sequence'
             ORDER BY name""")
-        return [row[0] for row in cursor.fetchall()]
+        return [QName(None, row[0], True) for row in cursor.fetchall()]
 
-    def get_table_description(self, cursor, table_name):
+    def get_table_description(self, cursor, qualified_name):
         "Returns a description of the table, with the DB-API cursor.description interface."
         return [(info['name'], info['type'], None, None, None, None,
-                 info['null_ok']) for info in self._table_info(cursor, table_name)]
+                 info['null_ok']) for info in self._table_info(cursor, qualified_name[1])]
 
-    def get_relations(self, cursor, table_name):
+    def get_relations(self, cursor, qualified_name):
         """
         Returns a dictionary of {field_index: (field_index_other_table, other_table)}
         representing all relationships to the given table. Indexes are 0-based.
         """
+        table_name = qualified_name[1]
 
         # Dictionary of relations to return
         relations = {}
@@ -98,16 +100,18 @@
 
                 name = other_desc.split(' ', 1)[0].strip('"')
                 if name == column:
-                    relations[field_index] = (other_index, table)
+                    relations[field_index] = (other_index,
+                                              QName(None, table, True))
                     break
 
         return relations
 
-    def get_key_columns(self, cursor, table_name):
+    def get_key_columns(self, cursor, qname):
         """
         Returns a list of (column_name, referenced_table_name, referenced_column_name) for all
         key columns in given table.
         """
+        table_name = self.qname_converter(qname)[1]
         key_columns = []
 
         # Schema for this table
@@ -128,17 +132,20 @@
                 continue
 
             # This will append (column_name, referenced_table_name, referenced_column_name) to key_columns
-            key_columns.append(tuple([s.strip('"') for s in m.groups()]))
+            add = tuple([s.strip('"') for s in m.groups()])
+            add = add[0], (None, add[1], True), add[2]
+            key_columns.append(add)
 
         return key_columns
 
-    def get_indexes(self, cursor, table_name):
+    def get_indexes(self, cursor, qualified_name):
         """
         Returns a dictionary of fieldname -> infodict for the given table,
         where each infodict is in the format:
             {'primary_key': boolean representing whether it's the primary key,
              'unique': boolean representing whether it's a unique index}
         """
+        table_name = qualified_name[1]
         indexes = {}
         for info in self._table_info(cursor, table_name):
             indexes[info['name']] = {'primary_key': info['pk'] != 0,
@@ -157,10 +164,12 @@
             indexes[name]['unique'] = True
         return indexes
 
-    def get_primary_key_column(self, cursor, table_name):
+    def get_primary_key_column(self, cursor, qname):
         """
         Get the column name of the primary key for the given table.
         """
+        qname = self.qname_converter(qname)
+        table_name = qname[1]
         # Don't use PRAGMA because that causes issues with some transactions
         cursor.execute("SELECT sql FROM sqlite_master WHERE tbl_name = %s AND type = %s", [table_name, "table"])
         results = cursor.fetchone()[0].strip()
@@ -180,3 +189,14 @@
                  'null_ok': not field[3],
                  'pk': field[5]     # undocumented
                  } for field in cursor.fetchall()]
+
+    def identifier_converter(self, identifier):
+        return identifier
+
+    def qname_converter(self, qname, force_schema=False):
+        # For SQLite force_schema does nothing, as the default schema is
+        # None.
+        assert isinstance(qname, QName)
+        assert not (qname.schema and qname.db_format)
+        return QName(None, self.connection.ops.qualified_name(qname)[1:-1],
+                     True)
Index: django/db/backends/sqlite3/creation.py
===================================================================
--- django/db/backends/sqlite3/creation.py	(revision 17914)
+++ django/db/backends/sqlite3/creation.py	(working copy)
@@ -33,19 +33,25 @@
 
     def sql_for_pending_references(self, model, style, pending_references):
         "SQLite3 doesn't support constraints"
+        if model in pending_references:
+            del pending_references[model]
         return []
 
     def sql_remove_table_constraints(self, model, references_to_delete, style):
         "SQLite3 doesn't support constraints"
         return []
 
+    def sql_create_schema(self, schema, verbosity):
+        "SQLite3 doesn't support schemas"
+        return
+
     def _get_test_db_name(self):
         test_database_name = self.connection.settings_dict['TEST_NAME']
         if test_database_name and test_database_name != ':memory:':
             return test_database_name
         return ':memory:'
 
-    def _create_test_db(self, verbosity, autoclobber):
+    def _create_test_db(self, verbosity, autoclobber, schemas):
         test_database_name = self._get_test_db_name()
         if test_database_name != ':memory:':
             # Erase the old test database
@@ -65,6 +71,9 @@
                     sys.exit(1)
         return test_database_name
 
+    def _create_test_schemas(self, verbosity, schemas, cursor):
+        return []
+
     def _destroy_test_db(self, test_database_name, verbosity):
         if test_database_name and test_database_name != ":memory:":
             # Remove the SQLite database file
@@ -81,7 +90,6 @@
         SQLite since the databases will be distinct despite having the same
         TEST_NAME. See http://www.sqlite.org/inmemorydb.html
         """
-        settings_dict = self.connection.settings_dict
         test_dbname = self._get_test_db_name()
         sig = [self.connection.settings_dict['NAME']]
         if test_dbname == ':memory:':
